﻿namespace TabsStudioMvcGroup
{
    class SuperGroup
    {
        public SuperGroup()
        {
            superGroupProperties = new TabsStudioExt.Util.SuperGroupProperties();
        }

        public void UpdateProperties(System.Windows.Controls.Panel panel)
        {
            foreach (System.Windows.Controls.TabItem i in panel.Children)
            {
                if (superGroupProperties.GetName(i) == superGroupName)
                {
                    superGroupProperties.SetName(i, null);
                    superGroupProperties.SetFirstTab(i, false);
                    superGroupProperties.SetLastTab(i, false);
                }
            }

            for (int i = 0; i < panel.Children.Count; ++i)
            {
                System.Windows.Controls.TabItem tab = TabItemChild(panel, i);
                TabInfo currentInfo = Properties.GetTabInfo(tab);
                if (currentInfo.type != TabType.Unknown)
                {
                    superGroupProperties.SetName(tab, superGroupName);
                    superGroupProperties.SetFirstTab(tab,
                        i == 0 || !TabInfo.SameGroup(currentInfo, Properties.GetTabInfo(TabItemChild(panel, i - 1))));
                    superGroupProperties.SetLastTab(tab,
                        i == panel.Children.Count - 1 || !TabInfo.SameGroup(currentInfo, Properties.GetTabInfo(TabItemChild(panel, i + 1))));
                }
            }
        }

        public void UpdateDeletedProperties(System.Windows.Controls.TabItem deletedTabItem,
                         System.Windows.Controls.Panel panel)
        {
            if (superGroupProperties.IsFirstTab(deletedTabItem))
            {
                int nextTabIndex = panel.Children.IndexOf(deletedTabItem) + 1;
                if (nextTabIndex < panel.Children.Count)
                {
                    System.Windows.Controls.TabItem nextTab = TabItemChild(panel, nextTabIndex);
                    if (TabInfo.SameGroup(Properties.GetTabInfo(deletedTabItem), Properties.GetTabInfo(nextTab)))
                        superGroupProperties.SetFirstTab(nextTab, true);
                }
            }
            if (superGroupProperties.IsLastTab(deletedTabItem))
            {
                int prevTabIndex = panel.Children.IndexOf(deletedTabItem) - 1;
                if (prevTabIndex >= 0)
                {
                    System.Windows.Controls.TabItem prevTab = TabItemChild(panel, prevTabIndex);
                    if (TabInfo.SameGroup(Properties.GetTabInfo(deletedTabItem), Properties.GetTabInfo(prevTab)))
                        superGroupProperties.SetLastTab(prevTab, true);
                }
            }
        }

        private System.Windows.Controls.TabItem TabItemChild(System.Windows.Controls.Panel panel, int i)
        {
            return (System.Windows.Controls.TabItem)panel.Children[i];
        }

        private TabsStudioExt.Util.SuperGroupProperties superGroupProperties;
        private readonly string superGroupName = "[MvcGroup]";
    }
}
